#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_ActivityKillCrabLifeValueCFG.h"
std::auto_ptr<Fish_ActivityKillCrabLifeValueCFG> Fish_ActivityKillCrabLifeValueCFG::msSingleton(nullptr);

int Fish_ActivityKillCrabLifeValueCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_ActivityKillCrabLifeValueCFGData* Fish_ActivityKillCrabLifeValueCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_ActivityKillCrabLifeValueCFGData>& Fish_ActivityKillCrabLifeValueCFG::GetMapData()
{
	return mMapData;
}

void Fish_ActivityKillCrabLifeValueCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_ActivityKillCrabLifeValueCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_ActivityKillCrabLifeValueCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mLifeValue = element->IntAttribute("LifeValue");
		{
			const char* RewardItem = element->Attribute("RewardItem");
			std::vector<std::string> vecRewardItem;
			boost::split(vecRewardItem, RewardItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardItem[i].c_str(), &temp))
				{
					data.mRewardItem.push_back(temp);
				}
			}
		}
		{
			const char* RewardCount = element->Attribute("RewardCount");
			std::vector<std::string> vecRewardCount;
			boost::split(vecRewardCount, RewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardCount[i].c_str(), &temp))
				{
					data.mRewardCount.push_back(temp);
				}
			}
		}
		data.mNextLife = element->IntAttribute("NextLife");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_ActivityKillCrabLifeValueCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ActivityKillCrabLifeValueCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_ActivityKillCrabLifeValueCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_ActivityKillCrabLifeValueCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_ActivityKillCrabLifeValueCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "LifeValue", data.mLifeValue);
		LuaCfgHelper::readVectorInt(L, "RewardItem", data.mRewardItem);
		LuaCfgHelper::readVectorInt(L, "RewardCount", data.mRewardCount);
		LuaCfgHelper::readInt(L, "NextLife", data.mNextLife);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_ActivityKillCrabLifeValueCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_ActivityKillCrabLifeValueCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_ActivityKillCrabLifeValueCFG* Fish_ActivityKillCrabLifeValueCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_ActivityKillCrabLifeValueCFG());
	}
	return msSingleton.get();
}

void Fish_ActivityKillCrabLifeValueCFG::Release()
{
	msSingleton.reset(nullptr);
}
